/// <reference types="node" />
import { Queue, Worker } from "bullmq";
import { EventEmitter } from "events";
import { Config } from "../types/Config";
export declare type WorkerQueueProcessor = (job: WorkerQueueJob) => Promise<any>;
export interface WorkerQueueJob {
    name: string;
    id: string;
}
export declare class WorkerQueue {
    private config;
    private coordinatorRedis;
    private workerQueue;
    private worker;
    private queueEvents;
    private mode;
    constructor(config: Pick<Config, "workerQueueOptions" | "concurrency">);
    initializeAsWorker(workerQueueProcessor: WorkerQueueProcessor): Promise<Worker>;
    initializeAsMaster(maxTargets?: number): Promise<Queue<any, any, string>>;
    addJob(id: string, jobData?: any): Promise<EventEmitter | undefined>;
    closing(): Promise<void | undefined>;
    close(): Promise<void>;
}
